unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, IBServices, DBXpress, DB, SqlExpr,
  ImgList;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListView1: TListView;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    IBSecurityService1: TIBSecurityService;
    ImageList1: TImageList;
    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private declarations }
  public
    Tipo: byte;
    procedure CarregaUser;
  end;

var
  Form1: TForm1;

implementation

uses IB;

{$R *.dfm}

{ TForm1 }

procedure TForm1.CarregaUser;
var
  i: Integer;
  aLista: TListItem;
begin
  ListView1.Clear;
  with IBSecurityService1 do
  begin
    Active := True;
    DisplayUsers;
    for i := 0 to UserInfoCount - 1 do    { Iterate }
    begin
      with UserInfo[i] do
      begin
        aLista := ListView1.Items.Add;
        aLista.Caption := UserName;
        aLista.SubItems.Add(FirstName + ' ' +
          MiddleName + ' ' +
            LastName);
      end;
    end;
    Active := False;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  CarregaUser;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Tipo := 0;
  PageControl1.ActivePage := TabSheet2;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Tipo := 1;
  with IBSecurityService1 do
  begin
    Active := True;
    DisplayUser(ListView1.Selected.Caption);
    Edit1.Text := UserInfo[0].UserName;
    Edit2.Text := '';
    Edit3.Text := '';
    Edit4.Text := UserInfo[0].FirstName;
    Edit5.Text := UserInfo[0].MiddleName;
    Edit6.Text := UserInfo[0].LastName;
  end;
  PageControl1.ActivePage := TabSheet2;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  Tipo := 2;
  with IBSecurityService1 do
  begin
    Active := True;
    DisplayUser(ListView1.Selected.Caption);
    Edit1.Text := UserInfo[0].UserName;
    Edit4.Text := UserInfo[0].FirstName;
    Edit5.Text := UserInfo[0].MiddleName;
    Edit6.Text := UserInfo[0].LastName;
  end;
  PageControl1.ActivePage := TabSheet2;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  with IBSecurityService1 do
  begin
  try
    UserName := Edit1.Text;
    Password := Edit2.Text;
    FirstName := Edit4.Text;
    MiddleName := Edit5.Text;
    LastName := Edit6.Text;
    Active := True;
    case Tipo of
      0: AddUser;
      1: ModifyUser;
      2: DeleteUser;
    end;
    ShowMessage('Informao salva com sucesso');
    CarregaUser;
  except
  on E: EIBInterbaseError do
    raise Exception.Create(
      'J existe um usurio com esse nome');
  end;
  end;
end;

end.
